{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P-,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit dmChartUtils;

interface

uses
  Chart, Classes, CurvFitt, Graphics, Jpeg, Math, SysUtils, Series, TeEngine;

type
  tChartMode = ( cmResTime, cmArrh );
  tSourceType = (stExcel, stText );
  TChartCommon = class(TDataModule)
  procedure AdjustAxisStartStop( series : tChartSeries );
  procedure DrawNewLogAxis( var TheChart : tChart;
                            vertical : boolean;
                            OldAxis : tChartAxis;
                            series : tChartSeries );
  function GetChartJPEG(AChart:TCustomChart):TJPEGImage;
  function GetNextTic( value : double ) : double;
  function GetRoundLog( input : double; upward : boolean ) : double;
  Procedure ModifyAxis( chart : tChart; series : tChartSeries );
  procedure PlotSmoothFit( var serFit, serSmoothFit : tFastLineSeries;
                           FitFctn : TCurveFittingFunction;
                           smoothness : integer );
  function  SaveThisChart( theChart : tCustomChart;
                           OverWrite : boolean;
                           ChartPath : string;
                           var TheName : string ) : boolean;
    // Append date; add jpg if needed
    // Saves jpg and cht versions
  function SaveChart( TheChart : tCustomChart;
                      OverWrite : boolean;
                      fName : string ) : boolean;
    procedure DataModuleCreate(Sender: TObject);
    // user and date in path, and jpg extension expected
    // saves jpg and cht versions;
  private
    { Private declarations }
  public
    // AbscissaConverted : boolean; don'g think we need this...
    DataSourceFileName : string;
    ScaleAdjust : integer;
    TemperatureIndex,
    MaxLife : single;
  end;

var
  ChartCommon: TChartCommon;
  ChartMode : tChartMode;
  SourceType : tSourceType;
  enw : boolean;

implementation

{$R *.dfm}

uses Controls, Dialogs, TeeStore;

procedure TChartCommon.DataModuleCreate(Sender: TObject);
begin
  ScaleAdjust := 6;
  enw := fileExists( 'd:\data\fin\onlineacces.txt' )
  or FileExists( 'c:\users\jwc\desktop\onlineaccess.txt' );
  MaxLife := 20000;
  // or iMac when we get it...other machine?
end;

procedure tChartCommon.AdjustAxisStartStop( series : tChartSeries );

var dxy : real;
  dx, dy, xmax, ymax, xmin, ymin : double;

begin
  dxy := ScaleAdjust/100;
  with series do begin
    xMin := MinXvalue;
    xMax := MaxXvalue;
    yMin := MinYvalue;
    yMax := MaxYValue;
    dx := dxy * ( xMax - xMin );
    dy := dxy * ( ymax - ymin );
    GetHorizAxis.SetMinMax( xMin -dx, xMax +dx );
    GetVertAxis.SetMinMax( yMin -dy, yMax +dy );
  end
end;


Procedure tChartCommon.ModifyAxis( chart : tChart; series : tChartSeries );

var Value: Integer;
begin
  with Chart, Canvas do begin
    Pen.Style:=psDot;
    Pen.Color:=clGrayText;
    Font.Size:=Chart.LeftAxis.LabelsFont.Size+1;
    Value:=20;
    Line(LeftAxis.PosAxis - 4,LeftAxis.CalcPosValue(Value),
      BottomAxis.IEndPos,LeftAxis.CalcPosValue(Value));
    TextOut(LeftAxis.PosAxis - 20,
      LeftAxis.CalcPosValue(Value) - 6, InttoStr(Value));

    Value:=50;
    Line(LeftAxis.PosAxis - 4, LeftAxis.CalcPosValue(Value),
      BottomAxis.IEndPos,LeftAxis.CalcPosValue(Value));
    TextOut(LeftAxis.PosAxis - 20,
      LeftAxis.CalcPosValue(Value) - 6, InttoStr(Value));

    Value:=200;
    Line(LeftAxis.PosAxis - 4, LeftAxis.CalcPosValue(Value),
      BottomAxis.IEndPos,LeftAxis.CalcPosValue(Value));
    TextOut(LeftAxis.PosAxis - 28,
      LeftAxis.CalcPosValue(Value) - 6, InttoStr(Value));
  end;
end;

procedure tChartCommon.DrawNewLogAxis;
begin
  // this resides in interface during development, may move back here later...
end;

function tChartCommon.GetNextTic( value : double ) : double;

var y0 : integer; dy, mantissa : double;

begin
  Mantissa := frac( value );  // Only for numbers > 0
  If Mantissa < 0 then mantissa := 1 + mantissa;
  y0 := round( Power( 10, mantissa ));
  case y0 of
    1,5 : dy := log10( 2 );
    2 : dy := log10( 2.5 );
  end;
  Result := dy;
end;

function tChartCommon.GetRoundLog( input : double; upward : boolean ) : double;

var x, x1, x2, log2, log5, base : double;

begin
  log2 := log10( 2 );
  log5 := log10( 5 );
  if input = 0 then begin
    if upward then x := log2
    else x := -log2;
    result := x;
    exit;
  end;
  x := frac( input );
  if input < 0 then begin  //input = -1.82  = log (.015)
    x2 := 1+x;             // x2 = .18
    base := input - x2;    // base = -2
    x := x2
  end
  else begin
    base := input - x;
  end;
  if upward then begin
    if x < log10(2) then
      x1 := log2
    else   { >= 2 }
    if x < log10(5) then
      x1 := log5
    else
      x1 := 1
  end
  else begin {downward}
    if x > log10(5) then
      x1 := log5
  else
    if x > log10(2) then
      x1 := log2
  else
    x1 := 0
  end;
  if input < 0 then
    // x := base + (1-x1)
    x := x1 + base
  else
    x := x1 + base;
  result := x;
end;

(*
begin
  if input = 0 then begin
    if upward then x := log2
    else x := -log2;
    result := x;
    exit;
  end;
  x := frac( input );
  if input < 0 then begin  //input = -1.82  = log (.015)
    x2 := 1+x;             // x2 = .18
    base := input - x2;    // base = -2
    x := x2
  end
  else begin
    base := input - x;
  end;
  if upward then begin
    if x < log10(2) then
      x1 := log2
    else   { >= 2 }
    if x < log10(5) then
      x1 := log5
    else
      x1 := 1
  end
  else begin {downward}
    if x > log10(5) then
      x1 := log5
  else
    if x > log10(2) then
      x1 := log2
  else
    x1 := 0
  end;
  if input < 0 then
    // x := base + (1-x1)
    x := x1 + base
  else
    x := x1 + base;
  result := x;
end;
*)

procedure tChartCommon.PlotSmoothFit( var serFit, serSmoothFit : tFastLineSeries;
                           FitFctn : TCurveFittingFunction;
                           smoothness : integer );

var interval, x, y : double; i, imax : integer; coeffs : array of double;

begin
  with FitFctn do begin
    imax := polydegree;
    SetLength( coeffs, imax );
    if imax < 3 then
      coeffs[ 0 ] := 0;
    for i := 1 + ord( imax > 2) to imax do
      coeffs[ i-1 ] := AnswerVector[ i ];
    { end }
  end;
  with serFit do begin
    interval := ( maxXvalue - minXvalue )/ Smoothness;
    for i := 1 to Smoothness do begin
      x := minXvalue + (i-1) * interval;
      y := FitFctn. GetCurveYvalue( tChartSeries( serFit ), x );
      // y := poly( x-minXvalue, coeffs ) + minYvalue;
      serSmoothFit.AddXY( x, y )
    end
  end
end;

function TChartCommon.SaveThisChart( theChart : tCustomChart;
                        OverWrite : boolean;
                        ChartPath : string;
                        var TheName : string ) : boolean;

var
  lgt : word;
  Fname,       // fully qualified path and extension to save IMAGE
  thePath,
  tps : string;

begin     { SaveThisChart }
  // blank option added 06-20-2005
  tps := '';
  Fname := '';
  // if ChartPath <> '' then tps := flPathByDate( ChartPath ); 10-24-2009
  if ChartPath <> '' then tps := GetCurrentDir;
    // create if does not exist
  if pos ( '.jpg', TheName ) <> length( TheName ) - 3 then
    TheName := TheName + '.jpg';
  fname := tps + TheName;
  thePath := ExtractFileDir( fName ) + '\';
  Lgt := Length( ThePath );
    // we don't print the .jpg; that is in the interface as static text label.
  TheName := copy( fName, lgt + 1, Length( fName ) - ( lgt + 4 ));
  Result := SaveChart( TheChart, OverWrite, fName );
end;      { SaveThisChart }

function TChartCommon.SaveChart( TheChart : tCustomChart;
                    OverWrite : boolean;
                    fName : string ) : boolean;

var DoSave : boolean; ChartFname : string;

begin
  DoSave :=
    ( not FileExists( fName ))
    or OverWrite
    or ( MessageDlg( 'File ' + fName + ' exists; overwrite?',
      mtConfirmation, [mbYes, mbNo], 0 ) = mrYes );
    { end }
  if DoSave then
  with GetChartJPEG( theChart ) do
    try
      SaveToFile( fName );    { <-- save the JPEG to disk }
    finally
      Free;  { <-- free the temporary JPEG object }
    end;
  ChartfName := copy( fName, 1, Pos( '.', fName )) + 'cht';
    // And finally, save the CHART (not the image) with its dataset (true)
  SaveChartToFile( theChart, ChartFname, true );
    // Note that, as written, chart and dataset are saved to the file
    // and, presumably, an existing .cht file is overwritten.
  Result := DoSave;
end;      { SaveChart }

Function TChartCommon.GetChartJPEG;

var tmpBitmap:TBitmap;

begin
  result:=TJPEGImage.Create;   { <-- create a TJPEGImage }
  tmpBitmap:=TBitmap.Create;   { <-- create a temporary TBitmap }
  try
    tmpBitmap.Width := AChart.Width;   { <-- set the bitmap dimensions }
    tmpBitmap.Height:= AChart.Height;
    { draw the Chart on the temporary Bitmap... }
    AChart.Draw(tmpBitmap.Canvas,Rect(0,0,tmpBitmap.Width,tmpBitmap.Height));
    { set the desired JPEG options... }
    With result do
    begin
      GrayScale            :=False;
      ProgressiveEncoding  :=True;
      CompressionQuality   :=100;  // % 0 - 100
      PixelFormat          :=jf24bit;  // or jf8bit
      ProgressiveDisplay   :=True;
      Performance          :=jpBestQuality;  // or jpBestSpeed
      Scale                :=jsFullSize;  // or jsHalf, jsQuarter, jsEighth
      Smoothing            :=True;
        // Copy the temporary Bitmap onto the JPEG image...
      Assign(tmpBitmap);
    end;
  finally
    tmpBitmap.Free;  { <-- free the temporary Bitmap }
  end;
end;      { GetChartJpeg }

end.
